<!DOCTYPE html PUBLIC "-//W3C//DTD XHTML 1.0 Transitional//EN" "http://www.w3.org/TR/xhtml1/DTD/xhtml1-transitional.dtd">
<html xmlns="http://www.w3.org/1999/xhtml">
<head>
<meta http-equiv="Content-Type" content="text/xhtml;charset=UTF-8"/>
<meta http-equiv="X-UA-Compatible" content="IE=9"/>
<title>morphorobotx: ProtocolRegistration&lt; P &gt; Class Template Reference</title>
<link href="tabs.css" rel="stylesheet" type="text/css"/>
<script type="text/javascript" src="jquery.js"></script>
<script type="text/javascript" src="dynsections.js"></script>
<link href="search/search.css" rel="stylesheet" type="text/css"/>
<script type="text/javascript" src="search/search.js"></script>
<script type="text/javascript">
  $(document).ready(function() { searchBox.OnSelectItem(0); });
</script>
<link href="doxygen.css" rel="stylesheet" type="text/css" />
</head>
<body>
<div id="top"><!-- do not remove this div, it is closed by doxygen! -->
<div id="titlearea">
<table cellspacing="0" cellpadding="0">
 <tbody>
 <tr style="height: 56px;">
  <td style="padding-left: 0.5em;">
   <div id="projectname">morphorobotx
   </div>
   <div id="projectbrief">morphorobotxsharedlibrary</div>
  </td>
 </tr>
 </tbody>
</table>
</div>
<!-- end header part -->
<!-- Generated by Doxygen 1.8.1.2 -->
<script type="text/javascript">
var searchBox = new SearchBox("searchBox", "search",false,'Search');
</script>
  <div id="navrow1" class="tabs">
    <ul class="tablist">
      <li><a href="index.html"><span>Main&#160;Page</span></a></li>
      <li><a href="namespaces.html"><span>Namespaces</span></a></li>
      <li class="current"><a href="annotated.html"><span>Classes</span></a></li>
      <li><a href="files.html"><span>Files</span></a></li>
      <li>
        <div id="MSearchBox" class="MSearchBoxInactive">
        <span class="left">
          <img id="MSearchSelect" src="search/mag_sel.png"
               onmouseover="return searchBox.OnSearchSelectShow()"
               onmouseout="return searchBox.OnSearchSelectHide()"
               alt=""/>
          <input type="text" id="MSearchField" value="Search" accesskey="S"
               onfocus="searchBox.OnSearchFieldFocus(true)" 
               onblur="searchBox.OnSearchFieldFocus(false)" 
               onkeyup="searchBox.OnSearchFieldChange(event)"/>
          </span><span class="right">
            <a id="MSearchClose" href="javascript:searchBox.CloseResultsWindow()"><img id="MSearchCloseImg" border="0" src="search/close.png" alt=""/></a>
          </span>
        </div>
      </li>
    </ul>
  </div>
  <div id="navrow2" class="tabs2">
    <ul class="tablist">
      <li><a href="annotated.html"><span>Class&#160;List</span></a></li>
      <li><a href="classes.html"><span>Class&#160;Index</span></a></li>
      <li><a href="inherits.html"><span>Class&#160;Hierarchy</span></a></li>
      <li><a href="functions.html"><span>Class&#160;Members</span></a></li>
    </ul>
  </div>
<!-- window showing the filter options -->
<div id="MSearchSelectWindow"
     onmouseover="return searchBox.OnSearchSelectShow()"
     onmouseout="return searchBox.OnSearchSelectHide()"
     onkeydown="return searchBox.OnSearchSelectKey(event)">
<a class="SelectItem" href="javascript:void(0)" onclick="searchBox.OnSelectItem(0)"><span class="SelectionMark">&#160;</span>All</a><a class="SelectItem" href="javascript:void(0)" onclick="searchBox.OnSelectItem(1)"><span class="SelectionMark">&#160;</span>Classes</a><a class="SelectItem" href="javascript:void(0)" onclick="searchBox.OnSelectItem(2)"><span class="SelectionMark">&#160;</span>Namespaces</a><a class="SelectItem" href="javascript:void(0)" onclick="searchBox.OnSelectItem(3)"><span class="SelectionMark">&#160;</span>Files</a><a class="SelectItem" href="javascript:void(0)" onclick="searchBox.OnSelectItem(4)"><span class="SelectionMark">&#160;</span>Functions</a><a class="SelectItem" href="javascript:void(0)" onclick="searchBox.OnSelectItem(5)"><span class="SelectionMark">&#160;</span>Variables</a><a class="SelectItem" href="javascript:void(0)" onclick="searchBox.OnSelectItem(6)"><span class="SelectionMark">&#160;</span>Typedefs</a><a class="SelectItem" href="javascript:void(0)" onclick="searchBox.OnSelectItem(7)"><span class="SelectionMark">&#160;</span>Enumerations</a><a class="SelectItem" href="javascript:void(0)" onclick="searchBox.OnSelectItem(8)"><span class="SelectionMark">&#160;</span>Enumerator</a><a class="SelectItem" href="javascript:void(0)" onclick="searchBox.OnSelectItem(9)"><span class="SelectionMark">&#160;</span>Macros</a></div>

<!-- iframe showing the search results (closed by default) -->
<div id="MSearchResultsWindow">
<iframe src="javascript:void(0)" frameborder="0" 
        name="MSearchResults" id="MSearchResults">
</iframe>
</div>

</div><!-- top -->
<div class="header">
  <div class="summary">
<a href="#pub-types">Public Types</a> &#124;
<a href="#pub-methods">Public Member Functions</a> &#124;
<a href="#pub-attribs">Public Attributes</a> &#124;
<a href="classProtocolRegistration-members.html">List of all members</a>  </div>
  <div class="headertitle">
<div class="title">ProtocolRegistration&lt; P &gt; Class Template Reference</div>  </div>
</div><!--header-->
<div class="contents">

<p><code>#include &quot;<a class="el" href="Factory_8hpp_source.html">Factory.hpp</a>&quot;</code></p>
<div class="dynheader">
Collaboration diagram for ProtocolRegistration&lt; P &gt;:</div>
<div class="dyncontent">
<div class="center"><img src="structProtocolRegistration__coll__graph.png" border="0" usemap="#ProtocolRegistration_3_01P_01_4_coll__map" alt="Collaboration graph"/></div>
</div>
<table class="memberdecls">
<tr class="heading"><td colspan="2"><h2><a name="pub-types"></a>
Public Types</h2></td></tr>
<tr class="memitem:acb1944dd4c3f0742db6f5f109567f841"><td class="memItemLeft" align="right" valign="top">typedef P&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="structProtocolRegistration.html#acb1944dd4c3f0742db6f5f109567f841">ProtocolType</a></td></tr>
<tr class="memitem:af577017ca43a06ff5b55c7013902731d"><td class="memItemLeft" align="right" valign="top">typedef <a class="el" href="structTypedProtocolMaker.html">TypedProtocolMaker</a>&lt; P &gt;&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="structProtocolRegistration.html#af577017ca43a06ff5b55c7013902731d">Maker</a></td></tr>
</table><table class="memberdecls">
<tr class="heading"><td colspan="2"><h2><a name="pub-methods"></a>
Public Member Functions</h2></td></tr>
<tr class="memitem:ad14be68e5a3a949a135f869c545ef007"><td class="memItemLeft" align="right" valign="top">&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="structProtocolRegistration.html#ad14be68e5a3a949a135f869c545ef007">ProtocolRegistration</a> (QString n)</td></tr>
<tr class="memitem:ad7b35e71798516005186500959c3f0fa"><td class="memItemLeft" align="right" valign="top">&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="structProtocolRegistration.html#ad7b35e71798516005186500959c3f0fa">~ProtocolRegistration</a> ()</td></tr>
</table><table class="memberdecls">
<tr class="heading"><td colspan="2"><h2><a name="pub-attribs"></a>
Public Attributes</h2></td></tr>
<tr class="memitem:a53abeba6877c206afb32d35cfbe63ca4"><td class="memItemLeft" align="right" valign="top">QString&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="structProtocolRegistration.html#a53abeba6877c206afb32d35cfbe63ca4">name</a></td></tr>
<tr class="memitem:a7748bd3c1e9efdf353eac2651a6ed9c7"><td class="memItemLeft" align="right" valign="top">std::shared_ptr&lt; <a class="el" href="structProtocolRegistration.html#af577017ca43a06ff5b55c7013902731d">Maker</a> &gt;&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="structProtocolRegistration.html#a7748bd3c1e9efdf353eac2651a6ed9c7">maker</a></td></tr>
</table>
<a name="details" id="details"></a><h2>Detailed Description</h2>
<div class="textblock"><h3>template&lt;typename P&gt;<br/>
class ProtocolRegistration&lt; P &gt;</h3>

<p>Class used to register a protocol at load time, and then un-register it at unload time. This class is meant to be used through the <code>REGISTER_PROTOCOL</code> macro. </p>
</div><h2>Member Typedef Documentation</h2>
<a class="anchor" id="af577017ca43a06ff5b55c7013902731d"></a>
<div class="memitem">
<div class="memproto">
<div class="memtemplate">
template&lt;typename P &gt; </div>
      <table class="memname">
        <tr>
          <td class="memname">typedef <a class="el" href="structTypedProtocolMaker.html">TypedProtocolMaker</a>&lt;P&gt; <a class="el" href="structProtocolRegistration.html">ProtocolRegistration</a>&lt; P &gt;::<a class="el" href="structProtocolRegistration.html#af577017ca43a06ff5b55c7013902731d">Maker</a></td>
        </tr>
      </table>
</div><div class="memdoc">
<p>Type of the protocol make </p>

</div>
</div>
<a class="anchor" id="acb1944dd4c3f0742db6f5f109567f841"></a>
<div class="memitem">
<div class="memproto">
<div class="memtemplate">
template&lt;typename P &gt; </div>
      <table class="memname">
        <tr>
          <td class="memname">typedef P <a class="el" href="structProtocolRegistration.html">ProtocolRegistration</a>&lt; P &gt;::<a class="el" href="structProtocolRegistration.html#acb1944dd4c3f0742db6f5f109567f841">ProtocolType</a></td>
        </tr>
      </table>
</div><div class="memdoc">
<p>Type of the protocol created </p>

</div>
</div>
<h2>Constructor &amp; Destructor Documentation</h2>
<a class="anchor" id="ad14be68e5a3a949a135f869c545ef007"></a>
<div class="memitem">
<div class="memproto">
<div class="memtemplate">
template&lt;typename P &gt; </div>
<table class="mlabels">
  <tr>
  <td class="mlabels-left">
      <table class="memname">
        <tr>
          <td class="memname"><a class="el" href="structProtocolRegistration.html">ProtocolRegistration</a>&lt; P &gt;::<a class="el" href="structProtocolRegistration.html">ProtocolRegistration</a> </td>
          <td>(</td>
          <td class="paramtype">QString&#160;</td>
          <td class="paramname"><em>n</em></td><td>)</td>
          <td></td>
        </tr>
      </table>
  </td>
  <td class="mlabels-right">
<span class="mlabels"><span class="mlabel">inline</span></span>  </td>
  </tr>
</table>
</div><div class="memdoc">
<p>Register the protocol at instanciation time.</p>
<p>If the registration fails, aborts the application. </p>

<p><div class="dynheader">
Here is the call graph for this function:</div>
<div class="dyncontent">
<div class="center"><img src="structProtocolRegistration_ad14be68e5a3a949a135f869c545ef007_cgraph.png" border="0" usemap="#structProtocolRegistration_ad14be68e5a3a949a135f869c545ef007_cgraph" alt=""/></div>
<map name="structProtocolRegistration_ad14be68e5a3a949a135f869c545ef007_cgraph" id="structProtocolRegistration_ad14be68e5a3a949a135f869c545ef007_cgraph">
<area shape="rect" id="node3" href="Factory_8hpp.html#a260e511783256d65c1e55ed23434f7c9" title="factory" alt="" coords="204,13,265,43"/><area shape="rect" id="node5" href="classFactory.html#aa3472cb7ee0cf2a3368b9127a6dba236" title="Factory::instance" alt="" coords="315,13,437,43"/><area shape="rect" id="node7" href="classFactory.html#ac792bf88cfb7b6804b479529da5308cc" title="Factory::Factory" alt="" coords="487,13,604,43"/></map>
</div>
</p>

</div>
</div>
<a class="anchor" id="ad7b35e71798516005186500959c3f0fa"></a>
<div class="memitem">
<div class="memproto">
<div class="memtemplate">
template&lt;typename P &gt; </div>
<table class="mlabels">
  <tr>
  <td class="mlabels-left">
      <table class="memname">
        <tr>
          <td class="memname"><a class="el" href="structProtocolRegistration.html">ProtocolRegistration</a>&lt; P &gt;::~<a class="el" href="structProtocolRegistration.html">ProtocolRegistration</a> </td>
          <td>(</td>
          <td class="paramname"></td><td>)</td>
          <td></td>
        </tr>
      </table>
  </td>
  <td class="mlabels-right">
<span class="mlabels"><span class="mlabel">inline</span></span>  </td>
  </tr>
</table>
</div><div class="memdoc">
<p>Unregister the protocol at desctruction time.</p>
<p>If the un-registration fails, aborts the application. </p>

<p><div class="dynheader">
Here is the call graph for this function:</div>
<div class="dyncontent">
<div class="center"><img src="structProtocolRegistration_ad7b35e71798516005186500959c3f0fa_cgraph.png" border="0" usemap="#structProtocolRegistration_ad7b35e71798516005186500959c3f0fa_cgraph" alt=""/></div>
<map name="structProtocolRegistration_ad7b35e71798516005186500959c3f0fa_cgraph" id="structProtocolRegistration_ad7b35e71798516005186500959c3f0fa_cgraph">
<area shape="rect" id="node3" href="Factory_8hpp.html#a260e511783256d65c1e55ed23434f7c9" title="factory" alt="" coords="212,13,273,43"/><area shape="rect" id="node5" href="classFactory.html#aa3472cb7ee0cf2a3368b9127a6dba236" title="Factory::instance" alt="" coords="323,13,445,43"/><area shape="rect" id="node7" href="classFactory.html#ac792bf88cfb7b6804b479529da5308cc" title="Factory::Factory" alt="" coords="495,13,612,43"/></map>
</div>
</p>

</div>
</div>
<h2>Member Data Documentation</h2>
<a class="anchor" id="a7748bd3c1e9efdf353eac2651a6ed9c7"></a>
<div class="memitem">
<div class="memproto">
<div class="memtemplate">
template&lt;typename P &gt; </div>
      <table class="memname">
        <tr>
          <td class="memname">std::shared_ptr&lt;<a class="el" href="structProtocolRegistration.html#af577017ca43a06ff5b55c7013902731d">Maker</a>&gt; <a class="el" href="structProtocolRegistration.html">ProtocolRegistration</a>&lt; P &gt;::maker</td>
        </tr>
      </table>
</div><div class="memdoc">
<p>Instance of the protocol maker </p>

</div>
</div>
<a class="anchor" id="a53abeba6877c206afb32d35cfbe63ca4"></a>
<div class="memitem">
<div class="memproto">
<div class="memtemplate">
template&lt;typename P &gt; </div>
      <table class="memname">
        <tr>
          <td class="memname">QString <a class="el" href="structProtocolRegistration.html">ProtocolRegistration</a>&lt; P &gt;::name</td>
        </tr>
      </table>
</div><div class="memdoc">
<p>Name of the protocol created </p>

</div>
</div>
<hr/>The documentation for this class was generated from the following file:<ul>
<li><a class="el" href="Factory_8hpp_source.html">Factory.hpp</a></li>
</ul>
</div><!-- contents -->
<!-- start footer part -->
<hr class="footer"/><address class="footer"><small>
Generated on Tue Feb 26 2013 17:54:10 for morphorobotx by &#160;<a href="http://www.doxygen.org/index.html">
<img class="footer" src="doxygen.png" alt="doxygen"/>
</a> 1.8.1.2
</small></address>
</body>
</html>
